'===============================================================================
' Frequency Generator.bas
' Test of Trackbar 
' Created on January 30, 2015
' Latest changes on October 20, 2016
'===============================================================================

#Include "WinGUI.bi"

Dim As MSG msg
Dim Shared As HWND Win_Main, Track_Freq, Edit_Freq, Button_Ok, Button_Ton
Dim Shared f As Integer = 1000


Sub OpenWin_Main()
	'GUI
	
	Win_Main = Window_New			(100, 100, 550, 200, "Frequency Generator")
	Track_Freq = TrackBar_New	(20, 20, 300, 30,, Win_Main)
	Edit_Freq = EditBox_New		(330, 20, 70, 20, "1000",, Win_Main)
	Button_Ok = Button_New    (420, 20, 60, 20, "Ok",, Win_Main)
	Var Label_Freq = Label_New(20, 60, 300, 20, "Frequency 300 to 3000 Hz",, Win_Main)
	Button_Ton = Button_New		(170, 100, 60, 20, "Tone",, Win_Main)
	
	TrackBar_SetRange(Track_Freq, 300, 3000)
	TrackBar_SetPos(Track_Freq, f)
		
End Sub


Function Sine(ByVal t As Double) As Double
	'Sine function
	
	Const pi = 4 * Atn(1)
	
	Return Sin(2 * pi * f * t / 1000)
	
End Function


Sub DrawSine()
  'Draw sine function
  
  Dim As Double dt = 1e-3, t
	Dim As Integer i
	
	Screenres 500, 350, 32
	Windowtitle "Sine Tone, Time Span = 10 ms"
	Width 500\8, 350\8
	Color 0, &HFFFFFF
	Cls
	
	Window (0, -1.5) - (10, 1.5)
	Line (0, 0) - (10, 0)
  For i = 0 To 10000
		t = i * dt
		Pset (t, Sine(t)), &HFF0000
	Next
		
End Sub


Sub Track_Freq_Event()
	'Get frequency from trackbar, draw sine function
	
	f = TrackBar_GetPos(Track_Freq)
	EditBox_SetText(Edit_Freq, Str(f))
	DrawSine()
  	
End Sub


Sub Button_Ok_Event()
	'Get frequency from editbox, draw sine function
    
	f = Val(EditBox_GetText(Edit_Freq))
	If f < 300 Or f > 3000 Then
		MessageBox(0, "Frequency 300 to 3000 Hz!", "Error", MB_OK or MB_ICONERROR)
		Exit Sub
	End If
	TrackBar_SetPos(Track_Freq, f) 
	DrawSine()  

End Sub
	

Sub Button_Ton_Event()
	'Tone
	
	If f >= 300 and f <= 3000 Then Beep_(f, 1000)
	
End Sub


'Main:

OpenWin_Main()


Do
	WaitEvent(Win_Main, msg)
	Select Case msg.hwnd
	  Case Track_Freq
			If msg.message = WM_LBUTTONUP Then Track_Freq_Event()
		Case Button_Ok
		  If msg.message = WM_LBUTTONDOWN Then Button_Ok_Event()
		Case Button_Ton
			If msg.message = WM_LBUTTONDOWN Then Button_Ton_Event()
	End Select
Loop Until Window_Event_Close(Win_Main, msg)

End


