'=============================================================================
'GridTransfer.bas
'Author: RNBW (http://www.freebasic.net/forum/viewtopic.php?f=8&t=24617&start=15)
'
'Shows a grid of InputBoxes in 5 rows and 9 columns
'Includes Row and Column Headings
'Transfers values from one grid to another
'Code contributions gratefully received from Lothar Schirm,
'MrSwiss and fxm
'--------------------------------------------------------------------------------------------------------------
'Posted on 1April 2016
'Last Change on 11 July 2016 using Lothar Schirm's WinGui.bas Library
'Latest changes by Lothar Schirm on October 20, 2016
'=============================================================================
'
' INSTRUCTIONS:
' -------------------
' ENTER DATA INTO THE TOP GRID.
' WHEN COMPLETE CLICK <Click me!> Button.
' DATA WILL BE TRANSFERRED FROM TOP GRID TO BOTTOM GRID
'=============================================================================

#Include "WinGui.bi"

Dim As Long NumOfRows=5, NumOfCols=9
Dim As String sRows, sCols

Dim Shared As HWND Window_Main, Static_Text
Dim Shared As MSG msg
'Changed
Dim As String text, text2
Dim As HWND Edit_Text(1 To NumOfRows, 1 To NumOfCols)
Dim As HWND Edit_Text2(1 To NumOfRows, 1 To NumOfCols)
Dim As HWND Button_Click
Dim As Long vPos, hPos, bWidth, bHeight, row, col

'---------------------
' MAIN WINDOW
'---------------------
Sub OpenWindow_Main()
   Window_Main = Window_New(100, 100, 950, 400, "Test Inputbox - Multi-Column Grid")   
End Sub

OpenWindow_Main()

Button_Click = Button_New(10, 10, 100, 20, "Click me!",, Window_Main)

'-------------------------------
'  SET UP THE FIRST GRID
'-------------------------------
vPos = 40: bHeight = 20
For row = 1 To NumOfRows
   'hPos = 0 : bWidth = 0
   For col = 1 To 9
      Select Case col
      Case 1
         hPos = 10: bWidth = 65
      Case 2
         hPos = 75: bWidth = 380
      Case 3 To 8
         hPos = col*65+(455-65*3) : bWidth = 65
      Case 9
         hPos = (10+65+380)+(col-3)*65 : bWidth = 75
      End Select
      Edit_Text(row, col) = EditBox_New(hPos, vPos+bHeight*(row-1), bWidth+1, bHeight+1, "",, Window_Main)
   Next
Next

'----------------------------------
'  SET UP THE SECOND GRID
'----------------------------------
bHeight = 20
vPos = 40+bHeight*(NumOfRows+3)
For row = 1 To NumOfRows
   'hPos = 0 : bWidth = 0
   For col = 1 To 9
      Select Case col
      Case 1
         hPos = 10: bWidth = 65
      Case 2
         hPos = 75: bWidth = 380
      Case 3 To 8
         hPos = col*65+(455-65*3) : bWidth = 65
      Case 9
         hPos = (10+65+380)+(col-3)*65 : bWidth = 75
      End Select
      Edit_Text2(row, col) = EditBox_New(hPos, vPos+bHeight*(row-1), bWidth+1, bHeight+1, "",, Window_Main)
   Next
Next

'-----------------------------------
' SET UP HEADINGS IN ROW 1
' IN BOTH GRIDS
'-----------------------------------
row = 1
For col = 2 To NumOfCols
   EditBox_SetText(Edit_Text(row,col), "Col" + Str(col-1))
   EditBox_SetText(Edit_Text2(row,col), "Col" + Str(col-1))
Next

'----------------------------------
' SET UP HEADINGS IN COL 1
' IN BOTH GRIDS
'----------------------------------

col = 1
For row = 2 To NumOfRows
   For col = 1 To 1
      'text = text + " " + STR(row-1)
      'EditBox_SetText(Edit_Text(row,col), text)
      'text = "Row"
      EditBox_SetText(Edit_Text(row,col), "Row" + Str(row-1))
      EditBox_SetText(Edit_Text2(row,col), "Row" + Str(row-1))
   Next
Next

'-----------------------------------------
'Close out code and end program
'-----------------------------------------
Do
   WaitEvent(Window_Main, msg)
   Select Case msg.hwnd
   Case Button_Click
      If msg.message = WM_LBUTTONDOWN Then
         '-----------------------------------------
         ' GET VALUES FROM FIRST GRID
         ' AND TRANSFER TO SECOND GRID
         '-----------------------------------------
         For I As Integer = 1 To NumOfRows
            For J As Integer = 2 To 9
               EditBox_SetText(Edit_Text2(I,J), EditBox_GetText(Edit_Text(I,J)))
            Next J
         Next I
      End If
   End Select
Loop Until Window_Event_Close(Window_Main, msg)

End
